# coding=utf-8

"""
------------------------------- Parser -------------------------------
(C) COPYRIGHT 2016: nicolas """

import os
import sys
import uuid
import cStringIO
import traceback
import math

import ifcopenshell

########################################################################################################################

def write(filePath, inputList):

    if os.path.exists(filePath):
        os.remove(filePath)

    fileDescriptor = open(filePath, "w")
    fileDescriptor.writelines(inputList)

########################################################################################################################def read(filePath):

def read(beam):

    ret = []

    if not os.path.exists("TabelaVigas"):
        print "nao existe"
        return ret

    fileDescriptor = open("TabelaVigas", "r")
    lines = fileDescriptor.readlines()

    for line in lines:
        pos = line.find(beam)
        if pos >=0:
            NewObjectType = line.split(';')[0]

    return NewObjectType

########################################################################################################################

def readDatal():

    ret = []

    if not os.path.exists("Datal.txt"):
        print "nao existe"
        return ret

    ######################

    def getVector(strData):
        return [float(strData[strData.find(" E ") + 3: strData.find(" N ")]),
                float(strData[strData.find(" N ") + 3: strData.find(" U ")]),
                float(strData[strData.find(" U ") + 3:])]

    def findnth(haystack, needle, n):
        start = haystack.find(needle)
        while start >= 0 and n > 1:
            start = haystack.find(needle, start + len(needle))
            n -= 1
        return start

    insideSCTN = False
    startPos = []
    endPos = []
    beamName = []

    for line in open("Datal.txt", "r").readlines():

        if insideSCTN or line.startswith("NEW SCTN"):
            insideSCTN = True
            if line.startswith("SPRE"):
                beamName.append(line[findnth(line,'/',2)+1:].rstrip('\n'))

            elif line.startswith("POSS"):
                startPos.append(getVector(line))
            elif line.startswith("POSE"):
                endPos.append(getVector(line))
            elif line.startswith("END"):
                insideSCTN = False

    return beamName,startPos,endPos

########################################################################################################################

########################################################################################################################

def getAttrFromTable(beamName):
    ret = []

    if not os.path.exists("AISC_Shapes_Database.csv"):
        print "nao existe"
        return ret

    for line in open("AISC_Shapes_Database.csv", "r").readlines():
        pos = line.find(';'+beamName.upper())
        if pos >=0:
            beamAttributes = line.split(';')
    return beamAttributes

########################################################################################################################

def GetBeamStartPoint(beam):
    coord = beam.ObjectPlacement
    coord = coord.RelativePlacement
    coord = coord.Location
    coord = coord.Coordinates
    return coord

########################################################################################################################

def GetPipeStartPoint(pipe):
    coord = pipe.Representation
    coord = coord.Representations[0]
    coord = coord.Items[0]
    coord = coord.Position
    coord = coord.Location
    coord = coord.Coordinates
    return coord

########################################################################################################################
def GetBeamLenth(beam):
    beamlenth = beam.Representation
    beamlenth = beamlenth.Representations[0]
    beamlenth = beamlenth.Items
    beamlenth = beamlenth[0]
    beamlenth = beamlenth.Depth
    return beamlenth

########################################################################################################################

def GetPipeLength(pipe):
    pipelenth = pipe.Representation
    pipelenth = pipelenth.Representations[0]
    pipelenth = pipelenth.Items
    pipelenth = pipelenth[0]
    pipelenth = pipelenth.Depth
    return pipelenth

########################################################################################################################

def GetBeamDirection(beam):
    direction = beam.ObjectPlacement
    direction = direction.RelativePlacement
    direction = direction.RefDirection
    print direction
    if direction is None:
        direction = [1.0,0.0,0.0]
    else:
        direction = direction.DirectionRatios
    return direction

########################################################################################################################

def GetPipeDirection(pipe):
    direction = pipe.Representation
    direction = direction.Representations[0]
    direction = direction.Items[0]
    direction = direction.Position
    direction = direction.Axis
    print direction
    if direction is None:
        direction = [1.0,0.0,0.0]
    else:
        direction = direction.DirectionRatios
    return direction

########################################################################################################################

def printObject(data):
    print "id=" + str(data.id)
    print "is ifcbeam=" + str(data.is_a("ifcbeam"))
    print data.ObjectPlacement
    print data.GlobalId
    print data.Name
    print data.Description
    print data.Representation
    print data.ObjectType

########################################################################################################################

def writeDatalBeam(outputFileDescriptor, startPoint, endPoint, objectType):

    outputFileDescriptor.write("NEW SCTN\n")
    outputFileDescriptor.write("GTYP BOX\n")
    outputFileDescriptor.write("DRNS E 0 N\n")
    outputFileDescriptor.write("DRNE E 0 S\n")

    #POSS E 0.0mm N 0.0mm U 0.0mm
    outputFileDescriptor.write("POSS E " + str(startPoint[0]) + "mm N " + str(startPoint[1]) + "mm U " + str(startPoint[2]) + "mm\n")

    #POSE E 901.612121304mm N 0.0mm U 0.0mm
    outputFileDescriptor.write("POSE E " + str(endPoint[0]) + "mm N " + str(endPoint[1]) + "mm U " + str(endPoint[2]) + "mm\n")

    outputFileDescriptor.write("JUSL NA\n")
    outputFileDescriptor.write("SPRE SPCOMPONENT "+objectType+"\n\n")

########################################################################################################################

def createBeam(ifcFile, name, section, startPoint,beamLength, beamDirection):

    Z = 0.,0.,1.
    new_guid = ifcopenshell.guid.compress(uuid.uuid1().hex)
    owner_hist = ifcFile.by_type("IfcOwnerHistory")[0]
    point_origin =  ifcFile.by_type("IfcCartesianPoint")[0]
    beam_placement = ifcFile.by_type("IfcBuildingStorey")[0]

###############################CRIAR VIGA###########################
   # Beam Placement

    new_cart = ifcFile.createIfcCartesianPoint(startPoint)
    new_beamDirection = ifcFile.createIfcDirection(beamDirection)
    new_relplac = ifcFile.createIfcAxis2Placement3D(new_cart, None, Axis =  new_beamDirection, RefDirection =  ifcFile.createIfcDirection([0.,1.,0.]))

    objplac = ifcFile.createIfcLocalPlacement(beam_placement.ObjectPlacement, RelativePlacement = new_relplac)

    # Beam Representation part 1

    repr_axis2plac3d = ifcFile.createIfcAxis2Placement3D(point_origin, None, None)
    repr_new_direction = ifcFile.createIfcDirection([6.12303176911189E-17,1.])
    repr_newgeometric = ifcFile.createIfcGeometricRepresentationContext(None,'Model',3,0.01,repr_axis2plac3d,repr_new_direction)
    repres_subcontext = ifcFile.by_type("IfcGeometricRepresentationSubContext")[1]


    point_origin2d = point_origin =  ifcFile.by_type("IfcCartesianPoint")[1]
    new_cartesian_beamlength_point = ifcFile.createIfcCartesianPoint([beamLength,0.])
    new_polyline = ifcFile.createIfcPolyline([point_origin2d,new_cartesian_beamlength_point])


    # Beam Representation part 2
    if str(section).find('IfcLShapeProfileDef') >=0:
        beam_height = section.Depth
        beam_width = section.Width
    else:
        beam_height = section.OverallDepth
        beam_width = section.OverallWidth
    new_axis2placement3d_2 = ifcFile.createIfcAxis2Placement3D(ifcFile.createIfcCartesianPoint ( (0.,0.,0.) ))
    new_extrude_area = ifcFile.createIfcExtrudedAreaSolid(section, new_axis2placement3d_2, ifcFile.createIfcDirection(Z), beamLength)

    new_shape2 = ifcFile.createIfcShapeRepresentation(ifcFile.by_type("IfcGeometricRepresentationContext")[0], 'Body', 'SweptSolid',[new_extrude_area])
    new_representation = ifcFile.createIfcProductDefinitionShape(None,None,[new_shape2])
    new_beam = ifcFile.createIfcBeam(new_guid, owner_hist,'Viga_Converter_Testing_'+ name,
                                                                         None, 'Viga_Converter_Testing_description_'+ name,
                                                                                                        objplac,new_representation,Tag='my_tag')

    Flr1_Container = ifcFile.createIfcRelContainedInSpatialStructure(new_guid,owner_hist)
    Flr1_Container.RelatedElements=[new_beam]
    Flr1_Container.RelatingStructure= beam_placement
    ifcFile.write("out.ifc")

######################################################################################################################################################################


def W_Section(ifcFile, W, D, tw, tf, r):
    B1_Axis2Placement2D = ifcFile.createIfcAxis2Placement2D(
        ifcFile.createIfcCartesianPoint((0., 0.)))

    section = ifcFile.createIfcIShapeProfileDef('AREA')
    section.Position = B1_Axis2Placement2D
    section.OverallWidth = W
    section.OverallDepth = D
    section.WebThickness = tw
    section.FlangeThickness = tf
    section.FilletRadius = r
    return section


def L_Section(ifcFile,W, D, t, r):
    B1_Axis2Placement2D = ifcFile.createIfcAxis2Placement2D(
        ifcFile.createIfcCartesianPoint((0., 0.)))

    section = ifcFile.createIfcLShapeProfileDef('AREA')
    section.Position = B1_Axis2Placement2D
    section.Width = W
    section.Depth = D
    section.Thickness = t

    section.FilletRadius = r
    return section


def C_Section(ifcFile,W, D, tw, tf, r):
    B1_Axis2Placement2D = ifcFile.createIfcAxis2Placement2D(
        ifcFile.createIfcCartesianPoint((0., 0.)))

    section = ifcFile.createIfcUShapeProfileDef('AREA')
    section.Position = B1_Axis2Placement2D
    section.FlangeWidth = W
    section.Depth = D
    section.WebThickness = tw
    section.FlangeThickness = tf
    section.FilletRadius = r
    section.EdgeRadius = r * 0.5
    return section


def Rect_Section(ifcFile,b, h):
    B1_Axis2Placement2D = ifcFile.createIfcAxis2Placement2D(
        ifcFile.createIfcCartesianPoint((0., 0.)))

    section = ifcFile.createIfcRectangleProfileDef('AREA')
    section.Position = B1_Axis2Placement2D
    section.XDim = b
    section.YDim = h
    return section






######################################################################################################################################################################

def main():
    ifcFile = ifcopenshell.open("viga2.ifc")
    outputFile = open("test_viga.txt", "w")
    endpoint = [0.0,0.0,0.0]
    for beam in ifcFile.by_type("ifcbeam"):
        print ifcFile.by_type("ifcbeam")
        objectType = beam.Name
        print objectType
        objectTypePDMS = read(objectType)
        startPoint = GetBeamStartPoint(beam)
        beamLength = GetBeamLenth(beam)
        direction = GetBeamDirection(beam)
        endpoint[0] = startPoint[0] + beamLength * direction[0]
        endpoint[1] = startPoint[1] + beamLength * direction[1]
        endpoint[2] = startPoint[2] + beamLength * direction[2]
        writeDatalBeam(outputFile, startPoint, endpoint, objectTypePDMS)

    for pipe in ifcFile.by_type("IFCFLOWSEGMENT"):
        objectType = pipe.ObjectType
        startPoint = GetPipeStartPoint(pipe)
        pipelength = GetPipeLength(pipe)
        direction = GetPipeDirection(pipe)
        endpoint = [0.0, 0.0, 0.0]
        endpoint[0] = startPoint[0] + pipelength * direction[0]
        endpoint[1] = startPoint[1] + pipelength * direction[1]
        endpoint[2] = startPoint[2] + pipelength * direction[2]
        writeDatalBeam(outputFile, startPoint, endpoint, objectType)

    outputFile.close()


    #Write IFC Beam From Datal
    beamDatal = readDatal()
    beamNamesList =  beamDatal[0]
    beamStartPosList = beamDatal[1]
    beamEndPosList = beamDatal[2]

    print beamNamesList
    i=0
    for beam in beamNamesList:
        beamAttributes = getAttrFromTable(beam)

        beamSectionType = beamAttributes[0]
        if beamSectionType == 'W':
            section = W_Section(ifcFile,W=float(beamAttributes[63].replace(",",".")), D=float(beamAttributes[60].replace(",",".")), tw=float(beamAttributes[66].replace(",",".")), tf=float(beamAttributes[67].replace(",",".")), r=2 * float(beamAttributes[67].replace(",",".")))
        elif beamSectionType == 'L':
            section = L_Section(ifcFile,W=float(beamAttributes[64].replace(",",".")), D=float(beamAttributes[60].replace(",",".")), t=float(beamAttributes[68].replace(",",".")), r=2 * float(beamAttributes[68].replace(",",".")))
        elif beamSectionType == 'C':
            section = C_Section(ifcFile,W=float(beamAttributes[63].replace(",",".")), D=float(beamAttributes[61].replace(",",".")), tw=float(beamAttributes[66].replace(",",".")), tf=float(beamAttributes[67].replace(",",".")), r=2 * float(beamAttributes[67].replace(",",".")))
        else:
            section = Rect_Section(ifcFile,b=200, h=400)


        #calculo do comprimento da viga dado o ponto inicial e o final

        vetorDist = [(beamEndPosList[i][0]-beamStartPosList[i][0]),(beamEndPosList[i][1]-beamStartPosList[i][1]),(beamEndPosList[i][2]-beamStartPosList[i][2])]
        datalBeamLength = math.sqrt((math.pow(vetorDist[0],2))+(math.pow(vetorDist[1],2))+(math.pow(vetorDist[2],2)))

        # calculo da direção da viga
        datalBeamDirection = [(vetorDist[0]/datalBeamLength),(vetorDist[1]/datalBeamLength),(vetorDist[1]/datalBeamLength)]

        createBeam(ifcFile = ifcFile, name = beamNamesList[i],  section = section, startPoint = beamStartPosList[i], beamLength = datalBeamLength, beamDirection = datalBeamDirection)
        i += 1

########################################################################################################################

if __name__ == "__main__":

    try:
        main()
        print "Nao houve erros."
    except KeyboardInterrupt:
        error = 'Cancelado via Ctrl+C.'
        print error
    except Exception, e:
        exc_type, exc_value, tb = sys.exc_info()
        exc_file = cStringIO.StringIO()
        traceback.print_exception(exc_type, exc_value, tb, file=exc_file)
        exc_string = exc_file.getvalue()
        error = 'Excecao capturada: ' + exc_string + ' ' + e.message
        print error

    print 'Finalizado.'

########################################################################################################################