# coding=utf-8

import os
import sys
import uuid
import cStringIO
import traceback
import math
import re

import ifcopenshell

########################################################################################################################

def write(filePath, inputList):

    if os.path.exists(filePath):
        os.remove(filePath)

    fileDescriptor = open(filePath, "w")
    fileDescriptor.writelines(inputList)

########################################################################################################################def read(filePath):

def read(beam, DBInput):
    ret = []

    NewObjectType = ''

    if not os.path.exists(DBInput):
        print "nao existe"
        return ret

    fileDescriptor = open(DBInput, "r")
    lines = fileDescriptor.readlines()

    for line in lines:
        pos = line.find(beam)
        if pos >=0:
            NewObjectType = line.split(';', 2)[1]
            break

    return '/AISC/' + NewObjectType

########################################################################################################################

def readDatal(inputFile):

    ret = []

    if not os.path.exists(inputFile):
        print "nao existe"
        return ret

    def getVector(strData):

        try:
            ele1 = float( re.findall(r"\d*\.*\d+", strData[strData.find(" E ") + 3: strData.find(" N ")])[0])
        except:
            ele1 = float(strData[strData.find(" E ") + 3: strData.find(" N ")])
        try:
            ele2 = float( re.findall(r"\d*\.*\d+", strData[strData.find(" N ") + 3: strData.find(" U ")])[0])
        except:
            ele2 = float(strData[strData.find(" N ") + 3: strData.find(" U ")])
        try:
            ele3 = float( re.findall(r"\d*\.*\d+", strData[strData.find(" U ") + 3:])[0])
        except:
            ele3 = float(strData[strData.find(" U ") + 3:])

        return [ele1, ele2, ele3]

    def findnth(haystack, needle, n):
        start = haystack.find(needle)
        while start >= 0 and n > 1:
            start = haystack.find(needle, start + len(needle))
            n -= 1
        return start

    insideSCTN = False

    listSCTN = []

    for line in open(inputFile, "r").readlines():
        if line.startswith("NEW SCTN") or line.startswith("NEW ATTACHMENT"):
            insideSCTN = True
            dictSCTN = {
                'beamName': '',
                'startPos': [],
                'endPos': [],
                'angle': 0,
            }
        elif insideSCTN:
            if line.startswith("SPRE"):
                dictSCTN['beamName'] = line[findnth(line,'/',2)+1:].rstrip('\n')
            elif line.startswith("POSS"):
                dictSCTN['startPos'] = getVector(line)
            elif line.startswith("POSE"):
                dictSCTN['endPos'] = getVector(line)
            elif line.startswith("BANG"):
                dictSCTN['angle'] = int(re.findall(r"[+-]?\d*" ,line[5:])[0])
            elif line.startswith("END"):
                listSCTN.append(dictSCTN)
                insideSCTN = False

    return listSCTN

########################################################################################################################

def getAttrFromTable(beamName, DBInput):
    ret = []
    beamAttributes = ''
    if not os.path.exists(DBInput):
        print "nao existe"
        return ret

    for line in open(DBInput, "r").readlines():
        pos = line.find(';'+beamName.upper())
        if pos >=0:
            beamAttributes = line.split(';')
    return beamAttributes


########################################################################################################################

def GetBeamStartPoint(beam):
    coord = beam.ObjectPlacement
    coord = coord.RelativePlacement
    coord = coord.Location
    coord = coord.Coordinates
    return coord

########################################################################################################################

def GetPipeStartPoint(pipe):
    coord = pipe.Representation
    coord = coord.Representations[0]
    coord = coord.Items[0]
    coord = coord.Position
    coord = coord.Location
    coord = coord.Coordinates
    return coord

########################################################################################################################
def GetBeamLenth(beam):
    beamlenth = beam.Representation
    beamlenth = beamlenth.Representations[0]
    beamlenth = beamlenth.Items
    beamlenth = beamlenth[0]
    beamlenth = beamlenth.Depth
    return beamlenth

########################################################################################################################

def GetPipeLength(pipe):
    pipelenth = pipe.Representation
    pipelenth = pipelenth.Representations[0]
    pipelenth = pipelenth.Items
    pipelenth = pipelenth[0]
    pipelenth = pipelenth.Depth
    return pipelenth

########################################################################################################################

def GetBeamDirection(beam):
    direction = beam.ObjectPlacement
    direction = direction.RelativePlacement
    direction = direction.RefDirection
    print direction
    if direction is None:
        direction = [1.0,0.0,0.0]
    else:
        direction = direction.DirectionRatios
    return direction

########################################################################################################################

def GetPipeDirection(pipe):
    direction = pipe.Representation
    direction = direction.Representations[0]
    direction = direction.Items[0]
    direction = direction.Position
    direction = direction.Axis
    print direction
    if direction is None:
        direction = [1.0,0.0,0.0]
    else:
        direction = direction.DirectionRatios
    return direction

########################################################################################################################

def writeDatalBeam(outputFileDescriptor, startPoint, endPoint, objectType):

    outputFileDescriptor.write("NEW SCTN\n")
    outputFileDescriptor.write("GTYP BOX\n")
    outputFileDescriptor.write("DRNS E 0 N\n")
    outputFileDescriptor.write("DRNE E 0 S\n")

    #POSS E 0.0mm N 0.0mm U 0.0mm
    outputFileDescriptor.write("POSS E " + str(startPoint[0]) + "mm N " + str(startPoint[1]) + "mm U " + str(startPoint[2]) + "mm\n")

    #POSE E 901.612121304mm N 0.0mm U 0.0mm
    outputFileDescriptor.write("POSE E " + str(endPoint[0]) + "mm N " + str(endPoint[1]) + "mm U " + str(endPoint[2]) + "mm\n")

    outputFileDescriptor.write("JUSL NA\n")
    outputFileDescriptor.write("SPRE SPCOMPONENT "+objectType+"\n\n")

########################################################################################################################

def createBeam(ifcFile, name, section, startPoint, beamLength, beamDirection, curdir, ang):
    Z = 0., 0., 1.
    new_guid = ifcopenshell.guid.compress(uuid.uuid1().hex)
    owner_hist = ifcFile.by_type("IfcOwnerHistory")[0]
    point_origin =  ifcFile.by_type("IfcCartesianPoint")[0]
    beam_placement = ifcFile.by_type("IfcBuildingStorey")[0]

    ###CRIAR VIGA###

    # Beam Placement
    new_cart = ifcFile.createIfcCartesianPoint(startPoint)
    new_beamDirection = ifcFile.createIfcDirection(beamDirection)
    refDirection = ifcFile.createIfcDirection(ang)
    new_relplace = ifcFile.createIfcAxis2Placement3D(new_cart, Axis = new_beamDirection, RefDirection=refDirection)

    objplac = ifcFile.createIfcLocalPlacement(beam_placement.ObjectPlacement, RelativePlacement = new_relplace)

    # Beam Representation part 1
    repr_axis2plac3d = ifcFile.createIfcAxis2Placement3D(point_origin, None, None)
    repr_new_direction = ifcFile.createIfcDirection([6.12303176911189E-17,1., 1.])
    ifcFile.createIfcGeometricRepresentationContext(None,'Model',3,0.01,repr_axis2plac3d,repr_new_direction)


    point_origin2d = ifcFile.by_type("IfcCartesianPoint")[1]
    new_cartesian_beamlength_point = ifcFile.createIfcCartesianPoint([beamLength,0.])
    ifcFile.createIfcPolyline([point_origin2d,new_cartesian_beamlength_point])


    # Beam Representation part 2
    if str(section).find('IfcLShapeProfileDef') >=0:
        beam_height = section.Depth
        beam_width = section.Width
    else:
        beam_height = section.OverallDepth
        beam_width = section.OverallWidth

    new_axis2placement3d_2 = ifcFile.createIfcAxis2Placement3D(ifcFile.createIfcCartesianPoint ( (0.,0.,0.) ))
    new_extrude_area = ifcFile.createIfcExtrudedAreaSolid(section, new_axis2placement3d_2, ifcFile.createIfcDirection(Z), beamLength)

    new_shape2 = ifcFile.createIfcShapeRepresentation(ifcFile.by_type("IfcGeometricRepresentationContext")[0], 'Body', 'SweptSolid',[new_extrude_area])
    new_representation = ifcFile.createIfcProductDefinitionShape(None,None,[new_shape2])
    new_beam = ifcFile.createIfcBeam(new_guid, owner_hist,name, None, name, objplac,new_representation,Tag='my_tag')

    Flr1_Container = ifcFile.createIfcRelContainedInSpatialStructure(new_guid,owner_hist)
    Flr1_Container.RelatedElements=[new_beam]
    Flr1_Container.RelatingStructure= beam_placement
    # print "out " + str(os.path.join(curdir,"output\out.ifc"))

    ifcFile.write(os.path.join(curdir,"output\out.ifc"))

######################################################################################################################################################################

def W_Section(ifcFile, W, D, tw, tf, r):
    B1_Axis2Placement2D = ifcFile.createIfcAxis2Placement2D(
        ifcFile.createIfcCartesianPoint((0., 0.)))

    section = ifcFile.createIfcIShapeProfileDef('AREA')
    section.Position = B1_Axis2Placement2D
    section.OverallWidth = W
    section.OverallDepth = D
    section.WebThickness = tw
    section.FlangeThickness = tf
    section.FilletRadius = r
    return section


def L_Section(ifcFile,W, D, t, r):
    B1_Axis2Placement2D = ifcFile.createIfcAxis2Placement2D(
        ifcFile.createIfcCartesianPoint((0., 0.)))

    section = ifcFile.createIfcLShapeProfileDef('AREA')
    section.Position = B1_Axis2Placement2D
    section.Width = W
    section.Depth = D
    section.Thickness = t

    section.FilletRadius = r
    return section


def C_Section(ifcFile,W, D, tw, tf, r):
    B1_Axis2Placement2D = ifcFile.createIfcAxis2Placement2D(
        ifcFile.createIfcCartesianPoint((0., 0.)))

    section = ifcFile.createIfcUShapeProfileDef('AREA')
    section.Position = B1_Axis2Placement2D
    section.FlangeWidth = W
    section.Depth = D
    section.WebThickness = tw
    section.FlangeThickness = tf
    section.FilletRadius = r
    section.EdgeRadius = r * 0.5
    return section


def Rect_Section(ifcFile,b, h):
    B1_Axis2Placement2D = ifcFile.createIfcAxis2Placement2D(
        ifcFile.createIfcCartesianPoint((0., 0.)))

    section = ifcFile.createIfcRectangleProfileDef('AREA')
    section.Position = B1_Axis2Placement2D
    section.XDim = b
    section.YDim = h
    return section

######################################################################################################################################################################

def main(ifcInput, datalInput = None, DBInput = 'resources/AISC_Shapes_Database.csv', curdir = ""):
    try:
        if ifcInput is not None and datalInput is None:
            ifcFile = ifcopenshell.open(ifcInput)
            outputFile = open(os.path.join(curdir, "output/out.datal"), "w")
            # print "out: " + str(outputFile)
            endpoint = [0.0,0.0,0.0]

            for beam in ifcFile.by_type("ifcbeam"):
                # print ifcFile.by_type("ifcbeam")
                objectType = ';'+beam.Name+';'
                # print objectType
                objectTypePDMS = read(objectType, DBInput)
                startPoint = GetBeamStartPoint(beam)
                beamLength = GetBeamLenth(beam)
                direction = GetBeamDirection(beam)
                endpoint[0] = startPoint[0] + beamLength * direction[0]
                endpoint[1] = startPoint[1] + beamLength * direction[1]
                endpoint[2] = startPoint[2] + beamLength * direction[2]
                writeDatalBeam(outputFile, startPoint, endpoint, objectTypePDMS)

            for pipe in ifcFile.by_type("IFCFLOWSEGMENT"):
                objectType = ';'+pipe.ObjectType+';'
                startPoint = GetPipeStartPoint(pipe)
                pipelength = GetPipeLength(pipe)
                direction = GetPipeDirection(pipe)
                endpoint = [0.0, 0.0, 0.0]
                endpoint[0] = startPoint[0] + pipelength * direction[0]
                endpoint[1] = startPoint[1] + pipelength * direction[1]
                endpoint[2] = startPoint[2] + pipelength * direction[2]
                writeDatalBeam(outputFile, startPoint, endpoint, objectType)

            outputFile.close()

        if datalInput is not None:
            #Write IFC Beam From Data
            if ifcInput is '':
                ifcInput = os.path.join(curdir,'resources/temp.ifc')
            ifcFile = ifcopenshell.open(ifcInput)

            beamDatal = readDatal(datalInput)
            for beam in beamDatal:
                beamAttributes = getAttrFromTable(beam['beamName'], DBInput)
                if beamAttributes != '':
                    beamSectionType = beamAttributes[0]
                else:
                    continue
                if beamSectionType == 'W':
                    # print 'W'
                    # print beamAttributes[63]
                    section = W_Section(ifcFile,W=float(beamAttributes[63].replace(",",".")), D=float(beamAttributes[60].replace(",",".")), tw=float(beamAttributes[66].replace(",",".")), tf=float(beamAttributes[67].replace(",",".")), r=2 * float(beamAttributes[67].replace(",",".")))
                elif beamSectionType == 'L':
                    # print 'L'
                    # print beamAttributes[64]
                    section = L_Section(ifcFile,W=float(beamAttributes[64].replace(",",".")), D=float(beamAttributes[60].replace(",",".")), t=float(beamAttributes[68].replace(",",".")), r=2 * float(beamAttributes[68].replace(",",".")))
                elif beamSectionType == 'C':
                    # print 'C'
                    # print beamAttributes[63]
                    section = C_Section(ifcFile,W=float(beamAttributes[63].replace(",",".")), D=float(beamAttributes[61].replace(",",".")), tw=float(beamAttributes[66].replace(",",".")), tf=float(beamAttributes[67].replace(",",".")), r=2 * float(beamAttributes[67].replace(",",".")))
                else:
                    section = Rect_Section(ifcFile,b=200, h=400)

                #calculo do comprimento da viga dado o ponto inicial e o final
                vetorDist = [(beam['endPos'][0]-beam['startPos'][0]),(beam['endPos'][1]-beam['startPos'][1]),(beam['endPos'][2]-beam['startPos'][2])]
                datalBeamLength = math.sqrt((vetorDist[0]**2)+(vetorDist[1]**2)+(vetorDist[2]**2))

                # calculo da direção da viga
                datalBeamDirection = [(vetorDist[0]/datalBeamLength),(vetorDist[1]/datalBeamLength),(vetorDist[2]/datalBeamLength)]

                angle = [math.cos(math.radians(beam["angle"])), math.sin(math.radians(beam["angle"])), 0]
                createBeam(ifcFile = ifcFile, name = beam['beamName'],  section = section, startPoint = beam['startPos'], beamLength=datalBeamLength, beamDirection=datalBeamDirection, curdir=curdir, ang=angle)

    except Exception, err:
        exc_type, exc_value, tb = sys.exc_info()
        exc_file = cStringIO.StringIO()
        traceback.print_exception(exc_type, exc_value, tb, file=exc_file)
        exc_string = exc_file.getvalue()
        error = 'Excecao capturada: ' + exc_string + ' ' + err.message
        print error
        return err.message
    return 'OK'

########################################################################################################################

if __name__ == "__main__":

    # main(None, "dist/5123-TUB_EST.dtl")
    main(None, "suporte.dtl")
    print 'Finalizado.'

########################################################################################################################